-- So, it seems like COM_BufAddText doesn't 100% prevent the "Failed to add NetXCmd" errors, so this
-- script will make commands executed through it to run delayed if there is too much of them

local bufaddtext = COM_BufAddText
local addtextqueue = {}
local dequeue_per_frame = 5

rawset(_G, "COM_BufAddText", function(p, text)
    assert(p and p.valid)
    assert(text)

    table.insert(addtextqueue, { p, text })
end)

local function dequeue()
    for i = 1, dequeue_per_frame do
        if #addtextqueue == 0 then return end

        local entry = table.remove(addtextqueue, 1)

        -- Player left before command could be executed...
        if not entry[1].valid then continue end

        bufaddtext(entry[1], entry[2])
    end
end

addHook("ThinkFrame", function()
    if leveltime == 0 then return end -- Runs several times so better skip that one
    if defrosting then return end -- Same

    dequeue()
end)

addHook("IntermissionThinker", dequeue)
addHook("VoteThinker", dequeue)
