-- Hyudoroblame by Indev for Sunflower's Garden
-- Displays the item stolen by Hyudoro in console #MakeHitfeedReusable
-- Disclaimer: The comments above were added by AnimeSonic, so don't attack Indev
local cv_hyudoroblame = CV_RegisterVar({
	name = "hyudoroblame",
	defaultvalue = "On",
	possiblevalue = CV_OnOff,
	flags = CV_NETVAR,
})

local function rainbow(str)
    local colors = {'\133', '\135', '\130', '\131', '\136', '\132', '\137'}
    local buff = {}
    local len = #str

    for i = 0, len-1 do
        table.insert(buff, colors[i % 7 + 1])
        table.insert(buff, str:sub(i+1, i+1))
    end

    return table.concat(buff, "")
end

local function getItemStr(itemtype, amount)
    local item_names = {
        [KITEM_SAD] = {"sad face item", "sad face items"}, -- That is possible too, i guess
        [KITEM_NONE] = {"NOTHING HOW DID THAT EVEN HAPPEN", "NOTHING HOW DID THAT EVEN HAPPEN"}, -- Should never appear
        [KITEM_SNEAKER] = {"\131sneaker", "\131sneakers"},
        [KITEM_ROCKETSNEAKER] = {"\131rocket sneakers", "\131rocket sneakers"},
        [KITEM_INVINCIBILITY] = {rainbow("invincibility"), rainbow("invincibilities")},
        [KITEM_BANANA] = {"\133banana", "\133bananas"}, -- M M M M
        [KITEM_EGGMAN] = {"\133eggman monitor", "\133eggman monitors"},
        [KITEM_ORBINAUT] = {"\133orbinaut", "\133orbinauts"},
        [KITEM_JAWZ] = {"\133jawz", "\133jawz"},
        [KITEM_MINE] = {"\133mine", "\133mines"},
        [KITEM_BALLHOG] = {"\133ballhog", "\133ballhogs"},
        [KITEM_SPB] = {"\132self propelled bomb", "\132self propelled bombs"},
        [KITEM_GROW] = {"\132grow", "\132grows"},
        [KITEM_SHRINK] = {"\132shrink", "\132shrinks"},
        [KITEM_THUNDERSHIELD] = {"\133thunder shield", "\133thunder shields"},
        [KITEM_HYUDORO] = {"\132hyudoro", "\132hyudoros"}, -- lmao
        [KITEM_POGOSPRING] = {"\131pogo spring", "\131pogo springs"},
        [KITEM_KITCHENSINK] = {rainbow("kitchen sink"), rainbow("kitchen sinks")},
    }

    local name = item_names[itemtype][(amount > 1) and 2 or 1]..'\128'

    if amount > 1 then
        name = name.." x"..amount
    end

    return name
end

addHook("ThinkFrame", function()
	if not cv_hyudoroblame.value then return end

	for p in players.iterate do
		if not (p.mo and p.mo.valid) then continue end

		if p.kartstuff[k_stealingtimer] == 16 then
			for p2 in players.iterate do
				if not (p2.mo and p2.mo.valid) then continue end

				if p2.kartstuff[k_stolentimer] == p.kartstuff[k_stealingtimer] or -- so LOCALLY it's equal
				    p2.kartstuff[k_stolentimer] == (p.kartstuff[k_stealingtimer]+1) then -- ...but in netgames it's +1??????

                    local vname = p2.name
                    local endchar = string.sub(vname, #vname, #vname)

                    if endchar == 's' or endchar == 'S' then
                        vname = vname.."'"
                    else
                        vname = vname.."'s"
                    end

                    local itemtype = p.kartstuff[k_itemtype]
                    local amount = p.kartstuff[k_itemamount]

                    print(p.name.." stole "..vname.." "..getItemStr(itemtype, amount))
				end
			end
		end
    end
end)
