local cv_v1projectiles = CV_RegisterVar {
    name = "v1projectiles",
    defaultvalue = "Off",
    possiblevalue = CV_OnOff,
    flags = CV_NETVAR,
}

local function getProjectileSpeed(mo, pmo)
    local PROJSPEED
    local mapthing = mo.type

    local MISSILES = {
        [MT_ORBINAUT] = true,
        [MT_JAWZ] = true,
        [MT_JAWZ_DUD] = true,
        [MT_BALLHOG] = true,
        [MT_SPB] = true,
    }

    local missile = MISSILES[mapthing]

    if missile and mapthing ~= MT_BALLHOG then
		PROJSPEED = mobjinfo[mapthing].speed

        if gamespeed == 0 then
			PROJSPEED = FixedMul(PROJSPEED, FRACUNIT-FRACUNIT/4)
		elseif gamespeed == 2 then
			PROJSPEED = FixedMul(PROJSPEED, FRACUNIT+FRACUNIT/4)
        end

		PROJSPEED = FixedMul(PROJSPEED, mapobjectscale)
	else
        if gamespeed == 0 then
			PROJSPEED = 68*mapobjectscale
		elseif gamespeed == 2 then
			PROJSPEED = 96*mapobjectscale
		else
			PROJSPEED = 82*mapobjectscale
        end
    end

    local input = pmo.angle - mo.angle

    if input > ANGLE_180 then
        input = (ANGLE_MAX-input)+1
    end

    local backward = abs(input/ANG1) > 30

    --print(abs(input/ANG1))

    --print("Backward throw? "..tostring(backward))

    if backward then
        if mapthing == MT_BALLHOG then
            PROJSPEED = PROJSPEED/4
        elseif mapthing ~= MT_SPB then
            PROJSPEED = PROJSPEED/2
        end
    end

    return PROJSPEED
end

local function doV1Speed(mo)
    if cv_v1projectiles.value == 0 then return end

    -- Not doing it in MobjSpawn because at this point speed/angle/etc of object will not be set yet
    if not mo.v1speedinit then
        local pmo = mo.target

        if pmo then
            local speed = getProjectileSpeed(mo, pmo)
            local input = pmo.angle - mo.angle

            if input > ANGLE_180 then
                input = (ANGLE_MAX-input)+1
            end

            local finalspeed = max(speed, FixedMul(speed, FixedMul(
			    FixedDiv(pmo.player.speed, K_GetKartSpeed(pmo.player, false)), -- Multiply speed to be proportional to your own, boosted maxspeed.
			    (((180<<FRACBITS) - AngleFixed(input)) / 180) -- multiply speed based on angle diff... i.e: don't do this for firing backward :V
			)))

            P_InstaThrust(mo, mo.angle, finalspeed)

            if mo.type ~= MT_BALLHOG then
                mo.movefactor = finalspeed
            end
        end

        mo.v1speedinit = true
    end
end

addHook("MobjThinker", doV1Speed, MT_ORBINAUT)
addHook("MobjThinker", doV1Speed, MT_JAWZ)
addHook("MobjThinker", doV1Speed, MT_JAWZ_DUD)
addHook("MobjThinker", doV1Speed, MT_BALLHOG)
addHook("MobjThinker", doV1Speed, MT_SPB)
