-- Powermusic.lua by Indev
-- Allows someone to completely disable the power item music and let them listen to the (usual) fantastic map soundtrack without interruption
local cv_megamixthemes = nil
local save_megamixthemes = nil

local function findMegamixThemes()
    if DynMusic ~= nil and DynMusic.mmt ~= nil then
        return DynMusic.mmt.cv_megamixthemes
    end
end

local cv_powermusic = CV_RegisterVar({
    name = "powermusic",
    defaultvalue = 1,
    PossibleValue = CV_OnOff,
    flags = CV_CALL|CV_NOINIT,
    func = function(cv_powermusic)
        cv_megamixthemes = findMegamixThemes()

        if cv_megamixthemes ~= nil then
            if cv_powermusic.value and save_megamixthemes ~= nil then
                CV_Set(cv_megamixthemes, save_megamixthemes)

                if save_megamixthemes then
                    print("\131NOTICE:\128 megamixthemes has been enabled back")
                end
            else
                save_megamixthemes = cv_megamixthemes.value
                CV_Set(cv_megamixthemes, 0)

                if save_megamixthemes then
                    print("\131NOTICE:\128 megamixthemes has been disabled")
                end
            end
        end
    end
})

addHook("MusicChange", function(old, new, mflags, looping, position, prefadems, fadems)
    new = new:upper()
    old = old:upper()

    if (not cv_powermusic.value) and (new == "KGROW" or new == "KINVNC") then
        return old, mflags, looping, position, prefadems, fadems
    end
end)
